# coding: utf-8

from flask import Blueprint, jsonify, g
from flask_httpauth import HTTPBasicAuth
from SWSCloudCore.controllers.users import ControllerAPI
from SWSCloudCore.controllers.users import ControllerUsers


api = Blueprint('api', __name__, url_prefix='/api/v1')
auth = HTTPBasicAuth()

"""
TODO: Реализовать Процесс авторизации в версии API 2.0
- получаем емейл и секретный ключ
- создаём временный токен
- выдаём токен
"""


@auth.verify_password
def verify_password(username, password):
    if not ControllerAPI().auth(username, password):
        return False
    g.user_id = ControllerUsers().get_id_by_email(username)
    return True


@api.route('/')
@auth.login_required
def index():
    """
    curl -X POST http://localhost:5000/api/v1/ -u <email>:<secret>
    :return:
    """
    return jsonify(user_id=g.user_id)
