# coding: utf-8

from flask import Blueprint, jsonify
from SWSCloudAPI.API import auth
from SWSCloudCore.controllers.datacenters import ControllerDataCenters


api_v1_datacenters = Blueprint('datacenters', __name__, url_prefix='/api/v1/datacenters')


@api_v1_datacenters.route('/', methods=['GET'])
@auth.login_required
def index():
    """
    get containers list
    curl -X http://localhost:5000/api/v1/datacenters/ -u <email>:<secret>
    :return:
    """
    dc_list = ControllerDataCenters().get()
    return jsonify(total=dc_list.get('total'), items=dc_list.get('items'))
