# coding: utf-8

from flask import Blueprint, jsonify
from SWSCloudAPI.API import auth
from SWSCloudCore.controllers.plans import ControllerPlans

api_v1_pricing = Blueprint('pricing', __name__, url_prefix='/api/v1/pricing')


@api_v1_pricing.route('/pricing/vms/')
@auth.login_required
def pricing_vms():
    """
    get pricing list
    curl -X http://localhost:5000/api/v1/pricing/vms/ -u <email>:<secret>
    :return:
    """
    return jsonify(pricing=ControllerPlans().get_plans(status='active'))


@api_v1_pricing.route('/pricing/containers/')
@auth.login_required
def pricing_containers():
    """
    get pricing list
    curl -X GET http://localhost:5000/api/v1/pricing/containers/ -u <email>:<secret>
    :return:
    """
    return jsonify(pricing=100)
