from functools import wraps
from flask import redirect, url_for, request, session
from SWSCloudCore.models import Admins


def requires_login(f):
    @wraps(f)
    def decorated_function(*args, **kwargs):
        if 'admin_email' not in session or 'admin_id' not in session or 'admin_password' not in session:
            # flash(u'You need to be signed in for this page.')
            return redirect(url_for('administrator.logout', next=request.path))
        # auth user
        if not Admins.auth(session.get('admin_email'), session.get('admin_password')):
            return redirect(url_for("administrator.logout"))

        return f(*args, **kwargs)
    return decorated_function
