# coding: utf-8

from flask import Blueprint, flash, g, jsonify, redirect, render_template, request, session, url_for
from SWSCloudCore.controllers.administrators import ControllerAdministrators
from SWSCloudCore.controllers.tasks.manage import ControllerManageTasks
from SWSCloudCore.controllers.containers.manage import ControllerManageContainers
from SWSCloudCore.controllers.tasks import ControllerTasks
from SWSCloudCore import models
from SWSCloudAdministrator.Administrator.common import requires_login

view_administrator_compute_containers = Blueprint(
    'administrator_compute_containers', __name__, url_prefix='/administrator/compute/containers')


@view_administrator_compute_containers.route('/')
@requires_login
def index():
    # формируем список правил
    return render_template(
        'administrator/compute/containers/index.html',
        containers=models.Containers.get_items())
