# coding: utf-8

# from uuid import uuid4
# import validators

from flask import Blueprint, flash, g, jsonify, redirect, render_template, request, session, url_for

from SWSCloudCore.controllers.administrators import ControllerAdministrators
from SWSCloudCore.controllers.tasks.manage import ControllerManageTasks
from SWSCloudAdministrator.Administrator.common import requires_login
from SWSCloudCore import models

view_administrator_tasks = Blueprint('administrator_tasks', __name__, url_prefix='/administrator/tasks')


@view_administrator_tasks.route('/', methods=['GET'])
@requires_login
def index():
    return render_template(
        'administrator/tasks/index.html',
        total=models.Tasks.count_items(),
        tasks=ControllerManageTasks().get())


@view_administrator_tasks.route('/edit.html', methods=['GET'])
@requires_login
def edit():
    task_id = request.args.get('task_id')

    # TODO: check exists

    return render_template(
        'administrator/tasks/edit.html',
        task=ControllerManageTasks().get_task(task_id))


@view_administrator_tasks.route('/edit.html', methods=['POST'])
@requires_login
def edit_post():
    task_id = request.form.get('task_id')

    # TODO: check exists
    x = models.Tasks.update(status=request.form.get('status')).where(models.Tasks.id == task_id)
    x.execute()

    return redirect(url_for('administrator_tasks.edit', task_id=task_id))


@view_administrator_tasks.route('/delete.html', methods=['GET'])
@requires_login
def delete():
    task_id = request.args.get('task_id')

    # TODO: check exists

    return render_template(
        'administrator/tasks/delete.html',
        task=ControllerManageTasks().get_task(task_id)
    )


@view_administrator_tasks.route('/delete.html', methods=['POST'])
@requires_login
def delete_post():
    task_id = request.form.get('task_id')

    # TODO: check exists
    x = models.Tasks.delete().where(models.Tasks.id == task_id)
    x.execute()

    return redirect(url_for('administrator_tasks.index'))
