from SWSCloudCore.models import Vms


class Item:
    def __init__(self, val):
        self.val = val


class ControllerVMS(object):
    def __init__(self, user_id):
        self.user_id = user_id
        pass

    # TODO: DEPRECATED
    def get(self, vm_id=None):
        results = list()
        return Vms.select().where(Vms.user == self.user_id, Vms.id == vm_id).get() if vm_id else Vms.select().where(Vms.user == self.user_id)

    def get_items(self):
        items = list()
        for x in Vms.select().where(Vms.user == self.user_id):
            items.append(dict(id=str(x.id), datacenter=str(x.datacenter.id), plan=x.plan.id, hostname=x.hostname,
                              osname=x.os_name, ossuite=x.os_suite, ipv4=x.ipv4, ipv6=x.ipv6, status=x.status))
        return items

    def get_item(self, vm_id):
        return Vms.select().where(Vms.user == self.user_id, Vms.id == vm_id).get()

    def create(self, datacenter_id, server_id, vm_id,
               hostname, ipv4, ipv6, plan, platform,
               os_name, os_suite, status):
        Vms.create(
            id=vm_id,
            datacenter=datacenter_id,
            server=server_id,
            user=self.user_id,
            hostname=hostname,
            ipv4=ipv4,
            ipv6=ipv6,
            plan=plan,
            platform=platform,
            os_name=os_name,
            os_suite=os_suite,
            status=status
        )
        return True

    def exists(self, vm_id):
        if Vms.select().where(Vms.user == self.user_id, Vms.id == vm_id).count() == 0:
            return False
        return True

    def set_status(self, vm_id, status):
        """
        DEPRECATED
        :param vm_id:
        :param status:
        :return:
        """
        x = Vms.update(status=status).where(Vms.id == vm_id)
        x.execute()
        return True

    def status_set(self, vm_id, status):
        """

        :param vm_id:
        :param status:
        :return:
        """
        x = Vms.update(status=status).where(Vms.id == vm_id)
        x.execute()
        return True
