# coding: utf-8

import validators
from flask import Blueprint, g, render_template, session, redirect, url_for, jsonify
from flask import request, flash
from SWSCloudCore.controllers.billing import ControllerBilling
from SWSCloudCore.controllers.common import ControllerMessagesEmail
from SWSCloudCore.controllers.users import ControllerAPI
from SWSCloudCore.controllers.users import ControllerSSHKey
from SWSCloudCore.controllers.users import ControllerUsers
from SWSCloudCore.controllers.users import ControllerUsersDetails
from SWSCloudCore.controllers.users import ControllerUsersRecoveryCodes
from SWSCloudCore import models
from SWSCloudWeb.common import requires_login

viewBills = Blueprint('bills', __name__, url_prefix='/bills')


@viewBills.route('/')
@requires_login
def index():
    user_id = session['user_id']
    cub = ControllerBilling()

    if not cub.exists(user_id):
        cub.create(user_id, balance=0)

    return render_template(
        'default/billing/index.html',
        user_details=models.Users.get_by_id(user_id),
        user_balance=cub.get(user_id))


@viewBills.route('/charge.html')
@requires_login
def charge():
    user_id = session['user_id']
    cub = ControllerBilling()

    if not cub.exists(user_id):
        cub.create(user_id, balance=0)

    return render_template(
        'default/billing/charge.html',
        user_details=models.Users.get_by_id(user_id))


@viewBills.route('/payments.html')
@requires_login
def payments():
    user_id = session['user_id']
    cub = ControllerBilling()

    if not cub.exists(user_id):
        cub.create(user_id, balance=0)

    return render_template(
        'default/billing/payments.html',
        history=cub.transactions_get(user_id))


@viewBills.route('/account.json')
@requires_login
def account_balance_json():
    if not session.get('user_id'):
        return jsonify({}), 403

    user_id = session.get('user_id')
    cub = ControllerBilling()

    if not cub.exists(user_id):
        cub.create(user_id, balance=0)

    return jsonify(balance=models.UsersBalance.get_by_account(user_id))
